
package com.smartgwt.client.docs;

/**
 * {@link com.smartgwt.client.data.SimpleType SimpleTypes} support a mechanism for arranging
 * values into groups. <P> These {@link com.smartgwt.client.data.SimpleType#getGroupingModes
 * Grouping modes} can be applied to any SimpleType, but  some types already support a set of
 * builtin modes, as follows: <P> <b>Date Grouping modes</b> <ul> <li> day/dayOfWeek: Group by
 * week-day, all weeks </li> <li> dayOfMonth: Group by month-day, all months </li> <li> week:
 * Group by Week number, all years </li> <li> month: Group by Month number, all years </li> <li>
 * quarter: Group by Quarter, all years </li> <li> year: Group by Year </li> <li> upcoming:
 * Various specific date groups: Today, Yesterday, Last Week, Last Month, etc </li> <li> date:
 * Group by specific Date </li> <li> dayOfWeekAndYear: Group by week-day, week and year </li> <li>
 * dayOfMonthAndYear: Group by month-day, month and year </li> <li> weekAndYear: Group by
 * week-number and year </li> <li> monthAndYear: Group by month and year </li> <li>
 * quarterAndYear: Group by quarter and year </li> </ul> <P> <b>Time Grouping modes</b> <ul> <li>
 * hours: Group by hours value </li> <li> minutes: Group by minutes value </li> <li> seconds:
 * Group by seconds value </li> <li> milliseconds: Group by milliseconds value </li> </ul>
 */
public interface BuiltinGroupingModes {
}
